import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Label;
import java.awt.Panel;

import javax.swing.JTree;

import quadbase.datasourcemanager.manager.DataSourceManagerListener;
import quadbase.datasourcemanager.manager.DefaultDataSourceNode;
import quadbase.reportdesigner.designer.QbReportDesigner;

//Run this example from Report Designer install directory
//Report manager must be running
public class RDWithDataRegistry2 extends Applet implements DataSourceManagerListener {
	static final long serialVersionUID = 1;
	public QbReportDesigner designer;

	public static void main(java.lang.String[] args) {

		try {

			RDWithDataRegistry2 doReport = new RDWithDataRegistry2();
			doReport.doReportDesignerWithDataRegOptionApplet(null);

		} catch (Exception ex) {
			ex.printStackTrace();
		}

	}

	@Override
	public void init() {

		try {

			doReportDesignerWithDataRegOptionApplet(this);
			setLayout(new BorderLayout());
			Panel panel = new Panel();
			panel.setLayout(new BorderLayout());
			panel.add("Center", new Label("LOADING"));
			add("Center", panel);

		} catch (Exception ex) {
			ex.printStackTrace();
		}

	}

	public void doReportDesignerWithDataRegOptionApplet(Applet applet) throws Exception {
		// Connect to EspressManager
		QbReportDesigner.setServerAddress("127.0.0.1");
		QbReportDesigner.setServerPortNumber(22071);

		// Use images from jar file
		QbReportDesigner.setUseSysResourceImages(true);

		// QbReportDesigner (component, name of XML file, true = start from Data Source Manager false = start from Create a new report or open existing report choice before going to Data Source Manager
		designer = new QbReportDesigner(applet, "DataRegistry/sample.xml", true);
		designer.addDataSourceManagerListener(this);
		designer.setVisible(true);

	}

	public JTree modifyDataSourceTree(JTree tree) {

		// The following code will remove all nodes from the tree except for
		// the database nodes.
		DefaultDataSourceNode root = (DefaultDataSourceNode) tree.getModel().getRoot();
		for (int i = root.getChildCount() - 1; i >= 1; i--)
		{
			// System.out.println("removing");
			root.remove(i);
		}

		// The following code will prevent the user from adding any query or dataview.
		DefaultDataSourceNode databaseHeading = (DefaultDataSourceNode) root.getChildAt(0);
		for (int i = 0; i < databaseHeading.getChildCount(); i++)
		{
			((DefaultDataSourceNode) databaseHeading.getChildAt(i).getChildAt(0))
					.setAddEnabled(false);
			((DefaultDataSourceNode) databaseHeading.getChildAt(i).getChildAt(1))
					.setAddEnabled(false);
		}

		return tree;

	}

}